# Copyright 1999-2002 Gentoo Technologies, Inc.
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils

MY_P="Canna36p3"
CANNADIC_P="cannadic-0.94f"

S="${WORKDIR}/${MY_P}"

DESCRIPTION="A client-server based Kana-Kanji conversion system"
HOMEPAGE="http://canna.sourceforge.jp/"
KEYWORDS="x86 ~ppc sparc ~alpha"
LICENSE="as-is"
SLOT="0"
IUSE=""
SRC_URI="http://downloads.sourceforge.jp/canna/2181/${MY_P}.tar.gz
	http://cannadic.oucrc.org/${CANNADIC_P}.tar.gz"
DEPEND="virtual/glibc"
RDEPEND="${DEPEND}"

src_unpack() {
	unpack ${A}
	cd ${S}
	epatch ${FILESDIR}/${P}-conf.diff
	epatch ${FILESDIR}/${P}-conf-dicdir.diff
	epatch ${FILESDIR}/Canna36-canuumfix.patch
	epatch ${FILESDIR}/Canna36-latin.patch
	epatch ${FILESDIR}/Canna36-Imake.patch
	epatch ${FILESDIR}/Canna36-wconv.patch
	epatch ${FILESDIR}/${P}-dicdir.diff
	epatch ${FILESDIR}/${P}-sample-canna.diff
}

src_compile() {
	xmkmf || die
	make Makefiles || die
	# make includes
	make canna || die
	# make canuum
	(cd canuum
		xmkmf -a || die
		make || die
	)
	export PORTAGE_CANNAIDEO_DIR=${S}/dic/ideo
	export PORTAGE_CANNACMD_DIR=${S}/cmd
	export PORTAGE_CANNA_POD=${S}/dic/ideo/pubdic/pod
	# make cannadic
	(cd ${WORKDIR}/${CANNADIC_P}
		for i in ${S}/cmd/*; do
			if [ -d $i ]; then
				export PATH=$PATH:$i;
			fi
		done;
		sed 's/crxdic/crxdic -D $PORTAGE_CANNAIDEO_DIR\/grammar\/cnj.bits/' \
			${PORTAGE_CANNACMD_DIR}/mkbindic/mkbindic > \
			${PORTAGE_CANNACMD_DIR}/mkbindic/mkbindic.tmp
		chmod +x ${PORTAGE_CANNACMD_DIR}/mkbindic/mkbindic.tmp
		${PORTAGE_CANNACMD_DIR}/mkbindic/mkbindic.tmp -m gcanna.t
		${PORTAGE_CANNACMD_DIR}/mkbindic/mkbindic.tmp -s gcannaf.t
		cp README ${S}/README.gcanna
	)
}

src_install () {
	make DESTDIR=${D} install || die
	make DESTDIR=${D} install.man || die
	# install canuum
	(cd canuum
		make DESTDIR=${D} install || die
		make DESTDIR=${D} install.man || die
	)
	# install cannadic
	(cd ${WORKDIR}/${CANNADIC_P}
		install -o bin -g bin -m 664 gcanna*.c[bl]d gcannaf.t \
			${D}/var/lib/canna/dic/canna
	)
	dodoc CHANGES.jp ChangeLog INSTALL* README* WHATIS*
	exeinto /etc/init.d ; newexe ${FILESDIR}/canna.initd canna || die
	insinto /etc/conf.d ; newins ${FILESDIR}/canna.confd canna || die
	dodir /etc/env.d ; echo "CANNAHOST=\"localhost\"" > ${D}/etc/env.d/71canna
	touch ${D}/var/log/canna/.keep || die
}
